/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 313 (Figure A.4)
**
*/

new;
library rpb,pgraph;
rpbSet;

cls;

rho = 0~0.9;
nu = 1;
ns = 2^10;

rndCopulaSobol(3);
{u1,u2} = rndCopulaStudent2(rho,nu,ns);

rndCopulaSobol(3);
{u3,u4} = rndCopulaNormal2(rho,ns);

graphset;
  begwind;
  window(2,2,0);
    _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
    _plctrl = -1; _pstype = 4; _psymsiz = 5;
    _paxht = 0.22; _pnumht = 0.20; _ptitlht = 0.28;
    fonts("simplex simgrma");
    xlabel("\216U]1["); ylabel("\216U]2[");
    xtics(0,1,0.2,2); ytics(0,1,0.2,2);
 
  setwind(1);
    title("\216Normal copula\L\216\202r\201 = 0");
    _pcolor = 1;
    xy(u3[.,1],u4[.,1]);

  setwind(2);
    title("\216Normal copula\L\216\202r\201 = 90%");
    _pcolor = 2;
    xy(u3[.,2],u4[.,2]);

  setwind(3);
    title("\216Student's t copula\L\216\202r\201 = 0, \202n\201 = 1");
    _pcolor = 12;
    xy(u1[.,1],u2[.,1]);

  setwind(4);
    title("\216Student's t copula\L\216\202r\201 = 90%, \202n\201 = 1");
    _pcolor = 5;
    xy(u1[.,2],u2[.,2]);

    graphprt("-c=2 -cf=app1-2-2-1.eps");

  endwind;

