/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 332 (Figure A.8)
**
*/

new;
library rpb,pgraph;

cls;

datFileName = "data\\data-tdf";
loadm databuf = ^datFileName;

t = vread(databuf,"t");

y0 = vread(databuf,"y0");
y1 = vread(databuf,"y1");
y2 = vread(databuf,"y2");
y3 = vread(databuf,"y3");
y4 = vread(databuf,"y4");

graphset;  
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; _pltype = 6|3;
  _paxht = 0.22; _pnumht = 0.20; _ptitlht = 0.25;
  xtics(0,40,10,2);
  xlabel("\216t");

  ytics(0,1,0.2,2);

  setwind(1);
    _pcolor = 1|2;
    title("\216Risk premium of the risky asset \202\95\201");
    xy(t,y0~y1);

  setwind(2);
    _pcolor = 1|2;
    title("\216Volatility of the risky asset \202\37\201");
    xy(t,y0~y2);

  setwind(3);
    _pcolor = 1|2;
    title("\216Current wealth \202\37\201");
    xy(t,y0~y3);

  setwind(4);
    _pcolor = 1|2;
    title("\216Risk aversion \202\37\201");
    _plegstr = "Reference glide path\000Perturbed glide path";
    _plegctl = {2 5 4.5 4.5};
    xy(t,y0~y4);

    graphprt("-c=2 -cf=app1-3-3-4.eps");

  endwind;
