/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 348 (Exercise B.1.11)
**
*/

new;
library rpb,pgraph;

cls;

let mu    = 0.07 0.07 0.04 0.06; 
let sigma = 0.20 0.15 0.04 0.09;
r = 0.02;

let rho = 1.00 
          0.80 1.00
          0.30 0.20 1.00
          0.20 0.00 0.00 1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';

call invpd(rho);

print;
print "=====================  Question 2.a  =======================================";

x_star = invpd(cov)*(mu - r);
x_star = x_star / sumc(x_star);
mu_star = x_star'mu;
sigma_star = sqrt(x_star'cov*x_star);

A = ones(1,4); B = 1; C = 0; D = 0; Bounds = (-5~8) .* ones(4,1);

gamma_ = seqa(0,0.001,1001);
{x,mu_x,sigma_x,gamma_x,retcode} = Compute_MVO_Portfolio(mu,cov,A,B,C,D,Bounds,gamma_,0);

SR = (mu_x - r)./sigma_x;  
indx = maxindc(SR);
x = x[.,indx];

print ftosa(100*(x_star~x),"%lf",3,2);

beta_star = (cov*x_star)/(sigma_star^2);
pi_star = beta_star * (mu_star - r);
MR_star = (cov*x_star)/sigma_star;
SR_star = (mu_star - r)/sigma_star;

delta_star = zeros(4,1);

Results = 100*x_star~beta_star~100*MR_star~100*pi_star;
print ftosa(Results,"%lf",3,2);

print;
print "=====================  Question 2.b  =======================================";

A = ones(1,4); B = 1; C = 0; D = 0; Bounds = (0~1) .* ones(4,1);

gamma_ = seqa(0,0.0001,10001);
{x,mu_x,sigma_x,gamma_x,retcode} = Compute_MVO_Portfolio(mu,cov,A,B,C,D,Bounds,gamma_,0);

SR = (mu_x - r)./sigma_x;  
indx = maxindc(SR);
x = x[.,indx];
mu_x = mu_x[indx];
sigma_x = sigma_x[indx];

beta_x = (cov*x)/(x'*cov*x);
pi_x = beta_x * (mu_x - r);
MR_x = (cov*x)/sigma_x;
SR_x = (mu_x - r)/sigma_x;

delta = MR_star .* SR_star - MR_x .* SR_x;

Results = 100*x~beta_x~100*MR_x~100*pi_x~100*delta;
print ftosa(Results,"%lf",3,2);

print;
print "=====================  Question 2.c  =======================================";

A = ones(1,4); B = 1; C = 0; D = 0; Bounds = (0.10~1.00) .* ones(4,1);

gamma_ = seqa(0,0.0001,10001);
{x,mu_x,sigma_x,gamma_x,retcode} = Compute_MVO_Portfolio(mu,cov,A,B,C,D,Bounds,gamma_,0);

SR = (mu_x - r)./sigma_x;  
indx = maxindc(SR);
x = x[.,indx];
mu_x = mu_x[indx];
sigma_x = sigma_x[indx];

beta_x = (cov*x)/(x'*cov*x);
pi_x = beta_x * (mu_x - r);
MR_x = (cov*x)/sigma_x;
SR_x = (mu_x - r)/sigma_x;

delta = MR_star .* SR_star - MR_x .* SR_x;

Results = 100*x~beta_x~100*MR_x~100*pi_x~100*delta;
print ftosa(Results,"%lf",3,2);

print;
print "=====================  Question 2.d  =======================================";

let x = 0.00 0.00 0.50 0.50;
mu_x = x'mu;
sigma_x = sqrt(x'*cov*x);  

SR = (mu_x - r)./sigma_x;  
indx = maxindc(SR);
x = x[.,indx];
mu_x = mu_x[indx];
sigma_x = sigma_x[indx];

beta_x = (cov*x)/(x'*cov*x);
pi_x = beta_x * (mu_x - r);
MR_x = (cov*x)/sigma_x;
SR_x = (mu_x - r)/sigma_x;

delta = MR_star .* SR_star - MR_x .* SR_x;

Results = 100*x~beta_x~100*MR_x~100*pi_x~100*delta;
print ftosa(Results,"%lf",3,2);





        