/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 343 (Exercise B.1.6)
**
*/

new;
library rpb,pgraph;

cls;

print;
print "=====================  Question 2.c  =======================================";

let mu_te  = 5 2;
let vol_te = 5 3;

n = rows(vol_te);
e = ones(n,1);

m = 25;
x = zeros(m,n);
y = zeros(m,n);

i = 1;
do until i > n;
  x[.,i] = seqa(0,vol_te[i]/(m-1),m);
  y[.,i] = seqa(0,mu_te[i]/(m-1),m);
  i = i + 1;
endo;

alpha = vol_te[2]/vol_te[1];
mu_te3 = alpha*mu_te[1];
vol_te3 = alpha*vol_te[1];

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|6|3|3|6; _pcross = 0; _plwidth = 10; _pcolor = 1|2|3|4|5;

  ylabel("\216\202m\201(x | b) (in %)");
  xlabel("\216\202s\201(x | b) (in %)");
  xtics(0,6,1,2);
  ytics(0,6,1,2);

  _psym = vol_te~mu_te~e.*(11~5)~_pcolor[1:n]~e.*(1~10) |
          vol_te3~mu_te3~11~5~4~1~10 ;
  _pline = 1~3~vol_te[1]~0~vol_te[1]~6~1~0~10 |
           1~3~0~mu_te[1]~6~mu_te[1]~1~0~10 |
           1~1~vol_te3~0~vol_te3~4~1~0~10 |
           1~1~0~mu_te[2]~4~mu_te[2]~1~0~10 |
           1~1~0~mu_te3~4~mu_te3~1~0~10 ;
  theta = arctan(mu_te./vol_te)/pi*180;
  _pmsgstr = "IR(x | b)\000IR(y | b)\000x\000y\000z";
  _pmsgctl = vol_te[1]/1.5~mu_te[1]/1.5+0.10~0.20~theta[1]-5~1~1~12 |
             vol_te[2]/2~mu_te[2]/2+0.10~0.18~theta[2]-5~1~2~12 |
             vol_te[1]-0.20~mu_te[1]+0.10~0.20~0~1~1~8 |
             vol_te[2]-0.20~mu_te[2]+0.10~0.20~0~1~2~8 |
             vol_te3-0.20~mu_te3+0.10~0.20~0~1~4~8 ;
  graphprt("-c=2 -cf=app2-1-6-1.eps");
  xy(x,y);

print;
print "=====================  Question 3.b  =======================================";

mu_x0_b = -0.02;
mu_x_b  =  0.05;

te_x0_b = 0.01;
te_x_b = 0.05;
te_x_x0 = 0.03;

alpha = seqa(0,0.001,1001);

mu_z_b = alpha * mu_x_b;
te_z_b = alpha * te_x_b;

mu_z_b = mu_z_b ~ 
         ((1-alpha)*mu_x0_b + alpha*mu_x_b);
te_z_b = te_z_b ~
         (sqrt((1 - alpha) * te_x0_b^2 + alpha .* te_x_b^2 + (alpha^2-alpha) .* te_x_x0^2));

te_y_b = 0.03;
mu_y_b = 0.02;

te_target = te_y_b;
alpha1 = te_target / te_x_b;
mu_z1_b = alpha1*mu_x_b;
te_z1_b = alpha1*te_x_b;

print ftosa(100*alpha1,"alpha(z) = %lf",3,2);
print ftosa(100*mu_z1_b,"mu(z | b) = %lf",3,2);
print ftosa(100*te_z1_b,"sigma(z | b) = %lf",3,2);
print;

indx = Closest_Index(te_target,te_z_b[.,2]);
alpha2 = alpha[indx];
mu_z2_b = mu_z_b[indx,2];
te_z2_b = te_z_b[indx,2];
IR_z2_b = mu_z2_b/te_z2_b;

print ftosa(100*alpha2,"alpha(z(x0)) = %lf",3,2);
print ftosa(100*mu_z2_b,"mu(z(x0) | b) = %lf",3,2);
print ftosa(100*te_z2_b,"sigma(z(x0) | b) = %lf",3,2);
print ftosa(IR_z2_b,"IR(z(x0) | b) = %lf",3,2);

print;
print "=====================  Question 3.c  =======================================";

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _pcross = 1; _plwidth = 10; _pcolor = 1|2|3|4|5;

  ylabel("\216\202m\201(x | b) (in %)");
  xlabel("\216\202s\201(x | b) (in %)");
  xtics(0,6,1,2);
  ytics(-3,6,1,2);

  _psym = 100*te_x_b~100*mu_x_b~11~5~_pcolor[1]~1~10|
          100*te_x0_b~100*mu_x0_b~11~5~_pcolor[2]~1~10|
          100*te_target~100*mu_z1_b~11~5~_pcolor[4]~1~10|
          100*te_target~100*mu_z2_b~11~5~_pcolor[4]~1~10|
          100*te_target~100*mu_y_b~11~5~_pcolor[3]~1~10;
  _pmsgstr = "x\000x]0[\000y\000z\000z(x]0[)";
  _pmsgctl = 100*te_x_b-0.20~100*mu_x_b+0.10~0.20~0~1~1~8|
             100*te_x0_b-0.40~100*mu_x0_b+0.10~0.20~0~1~2~8|
             100*te_target-0.20~100*mu_y_b+0.10~0.20~0~1~3~8|
             100*te_target-0.20~100*mu_z1_b+0.10~0.20~0~1~4~8|
             100*te_target+0.10~100*mu_z2_b-0.30~0.20~0~1~4~8;
  _pline = 1~3~100*te_target~0~100*te_target~100*mu_z1_b~1~0~10;
  graphprt("-c=2 -cf=app2-1-6-2.eps");
  xy(100*te_z_b,100*mu_z_b);


