/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 358 (Exercise B.2.7)
**
*/

new;
library rpb,pgraph;

cls;

#include app2-2-7-1.src

__output = 0;

/*
**> Question 2
**
*/

let mu = 0.05 0.08 0.03;
let sigma = 0.12 0.15 0.05;
let rho = 1.00
          0.25  1.00
          0.00 -0.20 1.00;
rho = xpnd(rho);
call invpd(rho);
cov = rho .* sigma .* sigma';

print;
print "=====================  Question 2.a  =======================================";

let x = 0.30 0.30 0.40;

alpha = 0.99;
{es,mr,rc,prc} = Compute_RC_ES(x,mu,cov,alpha);

Results = (x~mr~rc~prc)|(error(0)~error(0)~es~error(0));
print ftosa(100*Results,"%lf",3,2);

print;
print "=====================  Question 2.b  =======================================";

{x,es,mr,rc,prc} = Compute_ERC_ES(0,mu,cov,alpha);
Results = (x~mr~rc~prc)|(error(0)~error(0)~es~error(0));
print ftosa(100*Results,"%lf",3,2);

print;
print "=====================  Question 2.c  =======================================";

let b = 0.70 0.20 0.10;

{x,es,mr,rc,prc} = Compute_RB_ES(0,mu,cov,alpha,b);
Results = (x~mr~rc~prc)|(error(0)~error(0)~es~error(0));
print ftosa(100*Results,"%lf",3,2);

print;
print "=====================  Question 2.d  =======================================";

let x = 0.80 0.50 -0.30;

{es,mr,rc,prc} = Compute_RC_ES(x,mu,cov,alpha);

Results = (x~mr~rc~prc)|(error(0)~error(0)~es~error(0));
print ftosa(100*Results,"%lf",3,2);

print;
print "=====================  Question 2.e  =======================================";

_rpb_algorithm = 2;
_rpb_Bounds = (-5~5);

let x = 40 -20 80;
{x,es,mr,rc,prc} = Compute_ERC_ES(x,mu,cov,alpha);
Results = (x~mr~rc~prc)|(error(0)~error(0)~es~error(0));
print ftosa(100*Results,"%lf",3,2);

let x = -60 -40 200;
{x,es,mr,rc,prc} = Compute_ERC_ES(x,mu,cov,alpha);
Results = (x~mr~rc~prc)|(error(0)~error(0)~es~error(0));
print ftosa(100*Results,"%lf",3,2);

let x = -30 -30 100;
{x,es,mr,rc,prc} = Compute_ERC_ES(x,mu,cov,alpha);
Results = (x~mr~rc~prc)|(error(0)~error(0)~es~error(0));
print ftosa(100*Results,"%lf",3,2);

print;
print "=====================  Question 2.f  =======================================";

let x = 0.80 0.50 -0.30;
{x,es,mr,rc,prc} = Compute_RB_ES(x,mu,cov,alpha,b);
Results = (x~mr~rc~prc)|(error(0)~error(0)~es~error(0));
print ftosa(100*Results,"%lf",3,2);

let x = 60 -20 60;
{x,es,mr,rc,prc} = Compute_RB_ES(x,mu,cov,alpha,b);
Results = (x~mr~rc~prc)|(error(0)~error(0)~es~error(0));
print ftosa(100*Results,"%lf",3,2);

let x = -70 50 120;
{x,es,mr,rc,prc} = Compute_RB_ES(x,mu,cov,alpha,b);
Results = (x~mr~rc~prc)|(error(0)~error(0)~es~error(0));
print ftosa(100*Results,"%lf",3,2);

print;
print "=====================  Question 3.d  =======================================";

let x = 0.30 0.30 0.40;
let mu = 0.05 0.08 0.03;
let sigma = 0.12 0.15 0.05;
let rho = 1.00
          0.25  1.00
          0.00 -0.20 1.00;
rho = xpnd(rho);
call invpd(rho);
let nu = 4 4 2;

rndseed 123;

Nr = 100;
Ns = 1000000;

all_es = zeros(nR,1);
all_mr = zeros(3,nR);
all_rc = zeros(3,nR);
all_prc = zeros(3,nR);
cov = 0;
mu = 0;

i = 1;
do until i > nR;
  u = rndCopulaNormal(rho,nS);
  t = cdftci(u,nu');
  R = mu' + sigma' .* t;
  mu = mu + meanc(R)/nR;
  cov = cov + vcx(R)/nR;
  {all_es[i],all_mr[.,i],all_rc[.,i],all_prc[.,i]} = Empirical_RC_ES(x,R,alpha);
  print /flush ftos(i,"Iteration = %lf",3,2);
  i = i + 1;
endo;

es = meanc(all_es);
mr = meanc(all_mr');
rc = meanc(all_rc');
prc = meanc(all_prc');

Results = (x~mr~rc~prc)|(error(0)~error(0)~es~error(0));
print ftosa(100*Results,"%lf",3,2);

{es,mr,rc,prc} = Compute_RC_ES(x,mu,cov,alpha);
Results = (x~mr~rc~prc)|(error(0)~error(0)~ES~error(0));
print ftosa(100*Results,"%lf",3,2);
