/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 362 (Exercise B.3.2)
**
*/

new;
library rpb,pgraph;

cls;

__output = 0;

/*
**> Question 1
**
*/

let sigma = 0.10 0.20 0.15 0.25 0.30;
let rho =   1.0
            0.6 1.0
            0.4 0.5 1.0
            0.3 0.3 0.2  1.0
            0.2 0.1 0.1 -0.5 1.0;

rho = xpnd(rho);
call invpd(rho);

n = rows(sigma);

cor0 = eye(n);
cor1 = ones(n,n); 

cov = rho .* sigma .* sigma';
cov0 = cor0 .* sigma .* sigma';
cov1 = cor1 .* sigma .* sigma';

x = ones(n,1)/n;

print;
print "=====================  Question 1.a  =======================================";

vol1 = sqrt(x'cov*x);
print ftosa(100*vol1,"%lf",3,4);
vol1 = Compute_vol1(sigma,rho);
print ftosa(100*vol1,"%lf",3,4);

print;
print "=====================  Question 1.b  =======================================";

sigma0 = sqrt(x'cov0*x);
sigma1 = sqrt(x'cov1*x); 
vol2 = sigma0~sigma1;
print ftosa(100*vol2,"%lf",3,4);
vol2 = Compute_vol2(sigma);
print ftosa(100*vol2',"%lf",3,4);

print;
print "=====================  Question 1.c  =======================================";

sigma = 0.20 * ones(n,1);
cov = rho .* sigma .* sigma';
vol3 = sqrt(x'cov*x);
print ftosa(100*vol3,"%lf",3,4);

vol3 = Compute_vol3(sigma[1],rho);
print ftosa(100*vol3,"%lf",3,4);

print;
print "=====================  Question 1.d  =======================================";

let sigma = 0.10 0.20 0.15 0.25 0.30;
scalar_rho = 0.73;
rho = diagrv(scalar_rho*ones(n,n),1.0);
cov = rho .* sigma .* sigma';
vol4 = sqrt(x'cov*x);
print ftosa(100*vol4,"%lf",3,4);

vol4 = sqrt( (1 - scalar_rho) * sigma0^2 + scalar_rho * sigma1^2);
print ftosa(100*vol4,"%lf",3,4);

/*
**> Question 2
**
*/

let sigma = 0.10 0.20 0.15 0.25 0.30;
let rho =   1.0
            0.6 1.0
            0.4 0.5 1.0
            0.3 0.3 0.2  1.0
            0.2 0.1 0.1 -0.5 1.0;

rho = xpnd(rho);
call invpd(rho);

n = rows(sigma);
cov = rho .* sigma .* sigma';

print;
print "=====================  Question 2.a  =======================================";

vol = sqrt(x'cov*x);
RC1 = (x .* (cov*x))/(vol^2);
print ftosa(100*(RC1'~sumc(RC1)),"%lf",3,3);

RC1 = Compute_RC1(sigma,rho);
print ftosa(100*(RC1'~sumc(RC1)),"%lf",3,3);

print;
print "=====================  Question 2.b  =======================================";


RC_0 = (x .* (cov0*x))/(sigma0^2);
RC_1 = (x .* (cov1*x))/(sigma1^2);
print ftosa(100*(RC_0'~sumc(RC_0)),"%lf",3,3);
print ftosa(100*(RC_1'~sumc(RC_1)),"%lf",3,3);
print;

RC_0 = sigma^2/sumc(sigma^2);
RC_1 = sigma/(n*meanc(sigma));
print ftosa(100*(RC_0'~sumc(RC_0)),"%lf",3,3);
print ftosa(100*(RC_1'~sumc(RC_1)),"%lf",3,3);

print;
print "=====================  Question 2.c  =======================================";

sigma = 0.20 * ones(n,1);
cov = rho .* sigma .* sigma';
vol = sqrt(x'cov*x);
RC3 = (x .* (cov*x))/(vol^2);
print ftosa(100*(RC3'~sumc(RC3)),"%lf",3,3);

RC3 = Compute_RC3(sigma[1],rho);
print ftosa(100*(RC3'~sumc(RC3)),"%lf",3,3);

print;
print "=====================  Question 1.d  =======================================";

let sigma = 0.10 0.20 0.15 0.25 0.30;
scalar_rho = 0.250;
rho = diagrv(scalar_rho*ones(n,n),1.0);
cov = rho .* sigma .* sigma';
vol = sqrt(x'cov*x);

RC4 = (x .* (cov*x))/(vol^2);
print ftosa(100*(RC4'~sumc(RC4)),"%lf",3,3);

RC4 = (1-scalar_rho) * sigma0^2 * RC_0 + scalar_rho * sigma1^2 * RC_1;
RC4 = RC4 / (vol^2);
print ftosa(100*(RC4'~sumc(RC4)),"%lf",3,3);

print;
print "=====================  Question 3.a  =======================================";

n = 6;
x = ones(n,1)/n;

let beta_        = 0.30 0.20 0.50 0.50 0.40 0.50;
let sigma_tilde = 0.05 0.10 0.10 0.12 0.05 0.02;

sigma_m = 0.25;
sigma_m_sqr = sigma_m^2;

D = diagrv(zeros(n,n),sigma_tilde^2);
cov = sigma_m_sqr * beta_ * beta_' + D;

vol1 = sqrt(x'cov*x);
print ftosa(100*vol1,"%lf",3,4);

vol1 = 1/n * sqrt( sigma_m_sqr * sumc(vec(beta_ .* beta_')) + sumc(sigma_tilde^2));
print ftosa(100*vol1,"%lf",3,4);

print;
print "=====================  Question 3.b  =======================================";

vol = sqrt(x'cov*x);
RC2 = (x .* (cov*x))/vol;
print ftosa(100*(RC2'~sumc(RC2)/vol),"%lf",3,3);

sum_beta = sumc(beta_);
beta_bar = meanc(beta_);
RC2 = (n * sigma_m_sqr * beta_ * beta_bar + sigma_tilde^2) / (n^2 * vol);
print ftosa(100*(RC2'~sumc(RC2)/vol),"%lf",3,3);

print;
print "=====================  Question 3.c  =======================================";

rndseed 123456;

n = 50;
RC_exact = miss(zeros(n,4),0);
RC_approxim = miss(zeros(n,4),0);

beta_ = 0.5 + rndu(n,1);
sigma_tilde = 0.20 * rndu(n,1);
sigma_m = 0.25;
sigma_m_sqr = sigma_m^2;
D = diagrv(zeros(n,n),sigma_tilde^2);

let nVectors = 5 10 25 50;

i = 1;
do until i > 4;
  n = nVectors[i];
  x = ones(n,1)/n;

  cov = sigma_m_sqr * beta_[1:n] * beta_[1:n]' + D[1:n,1:n];
  vol = sqrt(x'cov*x);
  beta_bar = meanc(beta_[1:n]);
  RC_exact[1:n,i] = (n * sigma_m_sqr * beta_[1:n] * beta_bar + sigma_tilde[1:n]^2) / (n^2 * vol);
  RC_approxim[1:n,i] = beta_[1:n];

  i = i + 1;
endo;

RC_exact = RC_exact ./ sumc(missrv(RC_exact,0))';
RC_approxim = RC_approxim ./ sumc(missrv(RC_approxim,0))';

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pstype = 11; _plctrl = -1;
  _psymsiz = 8;
  _paxht = 0.24; _pnumht = 0.20; _ptitlht = 0.275;


  xlabel("\216Exact value (in %)");
  ylabel("\216Approximated value (in %)");
  _pline = 1~3~0~0~50~50~1~0~8;
  
  i = 1;
  do until i > 4;
    setwind(i);
      _pcolor = i;
      title("\216" $+ itos_rpb("n = ",nVectors[i]));
      if i == 1;
        xtics(0,30,10,2);
        ytics(0,30,10,2);
      elseif i == 2;
        xtics(0,20,5,2);
        ytics(0,20,5,2);
      elseif i == 3;
        xtics(2,7,1,2);
        ytics(2,7,1,2);
      elseif i == 4;
        xtics(0,4,1,2);
        ytics(0,4,1,2);
      endif;
      xy(100*RC_exact[.,i],100*RC_approxim[.,i]);

    i = i + 1;
  endo;

  graphprt("-c=2 -cf=app2-3-2-1.eps");

  endwind;


/*
**> Procedures
**
*/

proc (1) = Compute_vol1(sigma,rho);
  local n,cov,vol;

  n = rows(sigma);
  cov = diagrv(rho .* sigma .* sigma', error(0));
  cov = packr(vech(cov));
  vol = sqrt(sumc(sigma^2) + 2*sumc(cov))/n;

  retp(vol);
endp;

proc (1) = Compute_vol2(sigma);
  local n,vol0,vol1;

  n = rows(sigma);
  vol0 = sqrt(sumc(sigma^2))/n;
  vol1 = meanc(sigma);

  retp(vol0|vol1);
endp;

proc (1) = Compute_vol3(sigma,rho);
  local n,rho_bar,vol;

  n = rows(rho);
  rho_bar = diagrv(rho, error(0));
  rho_bar = meanc(packr(vech(rho_bar)));

  vol = sigma * sqrt( (1 + (n-1) * rho_bar)/n );

  retp(vol);
endp;

proc (1) = Compute_RC1(sigma,rho);
  local n,vol,RC;

  n = rows(sigma);
  vol = Compute_vol1(sigma,rho);

  rho = diagrv(rho,0);
  RC = sigma^2 + sigma .* sumr(rho .* sigma');
  RC = RC / (n^2 * vol^2);

  retp(RC);
endp;

proc (1) = Compute_RC3(sigma,rho);
  local n,rho_bar,rho_bar_i,RC;

  n = rows(rho);
  rho_bar = diagrv(rho, error(0));
  rho_bar = meanc(packr(vech(rho_bar)));

  rho_bar_i = diagrv(rho,0);
  rho_bar_i = sumc(rho_bar_i)/(n-1);

  RC = (1 + (n-1) * rho_bar_i) / ( n * (1 + (n-1) * rho_bar));

  retp(RC);
endp;
