/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 8 (Figure 1.2)
**
*/

new;
library rpb,pgraph;

cls;

let mu =    0.05 0.06 0.08 0.06;
let sigma = 0.15 0.20 0.25 0.30;
n = rows(sigma);
let rho =   1.00 
            0.10   1.00
            0.40   0.70   1.00
            0.50   0.40   0.80 1.00;
rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
A = ones(1,n); B = 1;

Bounds = (-10~10) .* ones(n,1);
gamma_ = seqa(-2,1/100,600);
{x0,mu0,sigma0,gamma0,retcode} = Compute_MVO_Portfolio(mu,cov,A,B,0,0,Bounds,gamma_,0);  

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 1;
  xtics(0,40,5,2);
  ytics(0,12,2,0);
  xlabel("\216Volatility (in %)");
  ylabel("\216Expected return (in %)");
  _psym = 100*sigma~100*mu~ones(n,1) .* (11~4.5~4~1~4) ;
  graphprt("-c=2 -cf=chap1-1-1-2.eps");
  xy(100*sigma0,100*mu0);

