/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 20 (Figure 1.6)
**
*/

new;
library rpb,pgraph;

cls;

let mu =    0.05 0.06 0.08 0.06;
let sigma = 0.15 0.20 0.25 0.30;
n = rows(sigma);
let rho =   1.00 
            0.10   1.00
            0.40   0.70   1.00
            0.50   0.40   0.80 1.00;
rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
A = ones(1,n); B = 1;

let b = 0.60 0.40 0.20 -0.20;

nRows = 251;
nCols = 3;

mu_TE = zeros(nRows,nCols);
vol_TE = zeros(nRows,nCols);

i = 1;
do until i > nCols;
  if i == 1;
    gamma_ = seqa(-1.0,3/500,251)/2;
    bounds = (-5~5) .* ones(n,1);
  elseif i == 2;
    gamma_ = seqa(-1.0,6/500,251)/2;
    bounds = (-0.1~5) .* ones(n,1);
  elseif i == 3;
    gamma_ = seqa(-1.0,3/500,251)/2;
    let bounds[4,2] =  0.0 0.5
                       0.0 0.5
                       0.0 0.5
                      -0.2 0.5;  
  endif;

  {x,mu_TE[.,i],vol_TE[.,i],gamma_x,retcode} = Compute_TE_Portfolio(b,mu,cov,0,0,0,0,Bounds,gamma_,0);

  i = i + 1;
endo;

vol_TE = 100 * vol_TE;
mu_TE = 100 * mu_TE;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 3|1|6; _pcross = 1; _plwidth = 10; _pcolor = 1|2|4;
  ylabel("\216\202m\201(x | b) (in %)");
  xlabel("\216\202s\201(x | b) (in %)");
  ytics(-0.75,0.75,0.25,2);
  xtics(0,5,1,2);
  _plegstr = "No constraint\000x]i[ \202\62 \201-10%\000x]i[[-] \202\60 \201x]i[ \202\60 \201x]i[[+]";
  _plegctl = {2 5 1.5 0.75}; 
  graphprt("-c=2 -cf=chap1-1-4-1.eps");
  xy(vol_TE,mu_TE);


