/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 21 (Figure 1.7)
**
*/

new;
library rpb,pgraph;

cls;

let mu =    0.05 0.06 0.08 0.06;
let sigma = 0.15 0.20 0.25 0.30;
n = rows(sigma);
let rho =   1.00 
            0.10   1.00
            0.40   0.70   1.00
            0.50   0.40   0.80 1.00;
rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
A = ones(1,n); B = 1;

let b = 0.60 0.40 0.20 -0.20;
gamma_ = seqa(-1.0,3/5000,5001);
let bounds[4,2] =  0.0 0.5
                   0.0 0.5
                   0.0 0.5
                  -0.2 0.5; 

{x,mu_TE,vol_TE,gamma_x,retcode} = Compute_TE_Portfolio(b,mu,cov,0,0,0,0,Bounds,gamma_,0);

vol_TE = 100 * vol_TE;
mu_TE = 100 * mu_TE;
IR = mu_TE ./ vol_TE;
indx = maxindc(IR);
x = x[.,indx];
gamma_x = gamma_x[indx];

print ftosa(100*x,"%lf",3,2);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _pcross = 1; _plwidth = 10; _pcolor = 4;
  ylabel("\216\202m\201(x | b) (in %)");
  xlabel("\216\202s\201(x | b) (in %)");
  ytics(-0.20,0.60,0.20,2);
  xtics(0,4,1,2);
  _psym = vol_TE[indx]~mu_TE[indx]~11~5~1~1~10 |
          vol_TE[indx]~0~11~5~1~1~10 |
          0~0~11~5~1~1~10 ;
  _pline = 4~3~0~0~1.42~0~0.51~1~10 |
           4~3~0~0~1.45~0~0.51~1~10 |
           1~3~0~0~vol_TE[indx]~mu_TE[indx]~0~1~10 |
           1~3~vol_TE[indx]~0~vol_TE[indx]~mu_TE[indx]~1~1~10;
  _pmsgstr = "\202Q\201";
  _pmsgctl = 1.5~0.1~0.12~0~1~1~8 ;  
  graphprt("-c=2 -cf=chap1-1-4-2.eps");
  xy(vol_TE,mu_TE);


