/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 65 (Figure 1.20)
**
*/

new;
library rpb,pgraph;

cls;

FileName = "results\\sampling-sx5e-june-2012";
loadm data = ^FileName;
data = rev(data);
n1 = rows(data);
x1 = data[.,1];
y1 = data[.,2];
x1_s = seqa(1,1,n1);
y1_s = fspline(csspline(x1,y1,1,0.05),x1_s);

FileName = "results\\sampling-spx-june-2012";
loadm data = ^FileName;
data = rev(data);
n2 = rows(data);
x2 = data[.,1];
y2 = data[.,2];
x2_s = seqa(1,1,n2);
y2_s = fspline(csspline(x2,y2,1,0.999),x2_s);

x = seqa(0,1/100,101);
y = fspline(csspline(x1/n1,y1,1,0.999),x)~fspline(csspline(x2/n2,y2,1,0.9999999),x);

graphset;
  window3d;

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plwidth = 10; 
  _paxht = 0.275;  _ptitlht = 0.275;  _pnumht = 0.22; 

  ylabel("\216\202s\201(x | b) (in %)");
  ytics(0,10,2,2);

  setwind(1);
    _pltype = 6; _pcolor = 1; 
    title("\216SX5E");
    xlabel("\216n]x[");
    xtics(0,n1,10,2);
    xy(x1_s,100*y1_s);

  setwind(2);
    _pltype = 1; _pcolor = 4;
    title("\216SPX");
    xtics(0,n2,100,2);
    xy(x2_s,100*y2_s);

  setwind(3);
    title("");
    _pltype = 6|1; _pcolor = 1|4;
    xlabel("\216n]x[/n]b[ (in %)");
    xtics(0,100,10,5);
    _plegstr = "SX5E\000SPX";
    _plegctl = {2 5 5 4};
    xy(100*x,100*y);

    graphprt("-c=2 -cf=chap1-2-4-9.eps");

  endwind;
