/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 196 (Figure 4.1)
**
*/

new;
library rpb,pgraph;

cls;

let params = 0.05 -0.05 0.06 10;

tau = seqa(1,1,5);
SpotRate = NelsonSiegel_Spot_Rate(params,tau);
print "Spot rates = ";
print ftosa(100*SpotRate,"%lf",3,2);

tau = seqa(0.001,0.10,401);

SpotRate = NelsonSiegel_Spot_Rate(params,tau);
m = 1/12~2;
ForwardRate = NelsonSiegel_Forward_Rate(params,tau,m);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3|1; _plwidth = 10; _pcolor = 1|4|2;
  xlabel("\216Maturity (in years)"); 
  xtics(0,30,5,12);
  ytics(0,6,1,2);
  _plegstr = "Spot\0001M forward\0002Y forward";
  _plegctl = {2 5 5 2};
  graphprt("-c=2 -cf=chap4-2-1-1.eps");
  xy(tau,100*(SpotRate~ForwardRate));


