/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 245 (Figure 5.1)
**
*/

new;
library rpb,pgraph;

cls;

datFileName = "data\\data-contango-backwardation";
loadm x = ^datFileName;

i = 1;
indx = 2*i-1|2*i;
data = packr(x[.,indx]);
dt = etdays2(data[1,1],data[.,1])/365;
x1 = dt~data[.,2];

i = 2;
indx = 2*i-1|2*i;
data = packr(x[.,indx]);
dt = etdays2(data[1,1],data[.,1])/365;
x2 = dt~data[.,2];

i = 3;
indx = 2*i-1|2*i;
data = packr(x[.,indx]);
dt = etdays2(data[1,1],data[.,1])/365;
x3 = dt~data[.,2];

i = 4;
indx = 2*i-1|2*i;
data = packr(x[.,indx]);
dt = etdays2(data[1,1],data[.,1])/365;
x4 = dt~data[.,2];

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 3; _plwidth = 10; _plctrl = 0|-1;
  _pstype = 8; _psymsiz = 4; 
  _pnumht = 0.21; _paxht = 0.21; _ptitlht = 0.25;

  xlabel("\216Maturity (in years)");

  xtics(0,9,1,0);

  setwind(1);
    title("\21629 May 2009");
    _pcolor = 1|5;
    ytics(70,95,5,0);
    xy(x1[.,1],x1[.,2 2]);

  setwind(3);
    title("\21629 May 2004");
    _pcolor = 3|5;
    ytics(28,36,2,0);
    xy(x3[.,1],x3[.,2 2]);

  setwind(4);
    title("\21629 May 2000");
    _pcolor = 4|5;
    ytics(18,34,4,0);
    xy(x4[.,1],x4[.,2 2]);

  setwind(2);
    title("\21629 May 2007");
    _pcolor = 2|5;
    ytics(70.5,73,0.5,0);
    xy(x2[.,1],x2[.,2 2]);    

    graphprt("-c=2 -cf=chap5-1-1-1.eps");

  endwind;

