proc (1) = Starting_Value(cov,mtd,t);
  local n,x0,sigma,exponent;

  n = rows(cov);

  if mtd == 1;                 // Asset-Weighted
    x0 = ones(n,1)/n;
  elseif mtd == 2;             // ERC Vol
    sigma = sqrt(diag(cov));
    exponent = -22*(1-1.05*n^0.02);
    x0 = (1/sigma) ./ (1 + meanc(cov./sigma./sigma')-1/n)^exponent;
  elseif mtd == 3;             // ERC ES
    if t <= 31 or (t >= 36 and t <= 75);     
      sigma = sqrt(diag(cov));
      exponent = -22*(1-1.05*n^0.02);
      x0 = (1/sigma)./(1 + meanc(cov./sigma./sigma')-1/n)^exponent;
    elseif t == 32;     //33 34 35
      x0 = {13,8,13,28,10,13,13,13,11,12};
    elseif t == 76;
      x0 = {18,10,10,10,10,10,10,10,10,10};
    else;
      x0 = ones(n,1)/n;
    endif;
  elseif mtd == 4;             // ERC CF
    sigma = sqrt(diag(cov));
    exponent = -22*(1-1.05*n^0.02);
    x0 = (1/sigma) ./ (1 + meanc(cov./sigma./sigma')-1/n)^exponent;
    
    if t == 41 or t == 42;
      x0 = {1,2,1,1,1,1,1,1,1,1};
    endif;
    
    if t == 49 or t == 89;
      x0 = {1,1,1,1,1,1,1,1,1,1};
    endif;
    
    if t == 96 or t == 95;
      x0 = {1,1.8,1,1,1,5,1,1,1,1};
    endif;
    
    if t == 91;
      x0 = {1,5,1,1,1,6,1,1,1,1};
    endif;
    
    if t == 39;
      x0 = {0.2,5,1,1,1,1,5,3,1,1};
    endif;   
    
    if t == 53;
      x0 = {5,6,1,0.1,0.1,5,16,0.5,8,0.5};
    endif;
  elseif mtd == 7;             // Factor CF
    x0 = ones(n,1)/n;
    if t == 80;
      x0 = {10,1,1,1,1,1,1,1,1,1};
    endif;
    
    if t == 49;
      x0 = {1,1,1,1,1,10,1,1,1,1};
    endif;
    
    if t == 44;
      x0 = {10,1,30,1,1,1,1,1,1,1};
    endif;
    
    if t == 46;
      x0 = {1,1,10,1,1,1,1,1,1,1};
    endif;
    
    if t == 83;
      x0 = {1,1,10,1,1,1,1,1,1,1};
    endif;
    
    if t == 45;
      x0 = {1,1,10,1,1,1,1,1,1,1};
    endif;
    
    if t == 48;
      x0 = {1,10,10,1,10,1,10,1,1,1};
    endif;
    
    if t == 53;
      x0 = {1,1,1,1,10,1,1,1,1,1};
    endif;
  else;
    x0 = {1,1,1,1,1,1,1,1,1,1};
  endif;

  x0 = x0/sumc(x0);

  retp(x0);
endp;