/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 266 (Limiting the turnover)
**
*/

new;
library rpb,pgraph;

cls;

let x0 = 0.25 0.30 0.10 0.35; 

let sigma = 0.20 0.15 0.25 0.20;
let rho   = 1.00
            0.20 1.00
            0.10 0.15 1.00
            0.20 0.20 0.15 1.00;
rho = xpnd(rho);
call invpd(rho);
cov = rho .* sigma .* sigma';
n = rows(cov);

RB = ones(n,1)/n;

{x1,vol1,mr1,rc1,prc1} = Compute_RB_Portfolio(x0,cov,RB);
tau1 = sumc(abs(x1-x0));

tau_max = 0.10;

sv = x0;

{x2,vol2,mr2,rc2,prc2,tau2} = Compute_RB_Turnover(sv,x0,cov,RB,tau_max);

alpha = tau_max/tau1;
x3 = alpha * x1 + (1-alpha) * x0;
tau3 = sumc(abs(x3-x0));

{x4,vol4,mr4,rc4,prc4,tau4} = Compute_RB_Turnover(x3,x0,cov,RB,tau_max);

cls;

print ftosa(100*(x0~x1~x2~x3~x4),"%lf",3,2);
print ftosa(100*(0~tau1~tau2~tau3~tau4),"%lf",3,2);

